package{
  import flash.geom.Rectangle;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import component.TextBox;

//--------------------------------------------------------------------//
// eLXg{bNX
  public class InfoBox extends TextBox{

// ږ\
    internal var field1:TextField;

// l\
    internal var field2:TextField;

//--------------------------------------------------------------------//
// fgColor - OiF
// textFormat - eLXg
    public function InfoBox(fgColor:uint,textFormat:TextFormat){
      field1=createField(textFormat);
      field1.multiline=true;
      field1.textColor=fgColor;
      field1.text="Lower temparature \nHeat flow to the system \n"
      	      	 +"Heat flow from the system \nWork of pump \n"
      	      	 +"Work of turbine \nThermodynamic efficiency ";
      field1.x=0;
      field1.y=0;
      field1.width=field1.textWidth+CL;
      field1.height=field1.textHeight+CL;
      field2=createField(textFormat);
      field2.multiline=true;
      field2.textColor=fgColor;
      field2.x=field1.width;
      field2.y=0;
      addChild(field1);
      addChild(field2);
    }

//--------------------------------------------------------------------//
// f[^ݒ肷
// cycle - LTCN
    public function setData(cycle:RankineCycle):void{
      field2.text=getStrings(cycle);
      field2.width=field2.textWidth+CL;
      field2.height=field2.textHeight+CL;
    }

//--------------------------------------------------------------------//
// `悷
// cycle - LTCN
    public function draw():void{
      graphics.clear();
      graphics.lineStyle(1,field1.textColor);
      graphics.drawRect(0,0,field1.width+field2.width,field1.height);
    }

//--------------------------------------------------------------------//
// TCNԂ
    protected function getStrings(cycle:RankineCycle):String{
      var enUnit:String=" [kJ/kg]";
      return "T1: "+format(cycle.sv1.t,4)+" [degC]"
      	    +"\nQ1: "+format(cycle.q1,4)+enUnit
      	    +"\nQ2: "+format(cycle.q2,4)+enUnit
      	    +"\nWp: "+format(cycle.wp,4)+enUnit
      	    +"\nWt: "+format(cycle.wt,4)+enUnit
      	    +"\nEta: "+format(cycle.efficiency,5);
    }
  }
}
