package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.MouseEvent;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import component.Button;

//--------------------------------------------------------------------//
// ANVǗNX
  public class RankineCycleActionManager{

// Xe[W
    internal var stage:Stage;

// LTCN\f
    internal var view:RankineCycleViewModel;

// ሳ͓̓tB[h
    internal var p1Field:TextField;

// ͓̓tB[h
    internal var p2Field:TextField;

// ^[rCx̓tB[h
    internal var t3Field:TextField;

//--------------------------------------------------------------------//
// sprite - eXvCg
// view - LTCN\f
// x,y,width - \ʒuA
// textFormat - eLXg
    public function RankineCycleActionManager(sprite:Sprite,
      	      	      	      	      	 view:RankineCycleViewModel,
      	      	      	      	      	 x:int,y:int,width:int,
      	      	      	      	      	 textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      addButtons(sprite,x,y,width,textFormat);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;

      var w:int=width/4;
      var x2:int=x+width*11/20;
      var x3:int=x2+w+5;
      var p1Label:TextField=
      	createLabel(x,y,"Lowew Pressure P1:",textFormat);
      p1Field=createInput(x2,y,w,"0.1",textFormat);
      var p1Unit:TextField=createLabel(x3,y,"MPa",textFormat);
      y+=p1Field.height+5;
      var p2Label:TextField=
      	createLabel(x,y,"Higher Pressure P2:",textFormat);
      p2Field=createInput(x2,y,w,"3.0",textFormat);
      var p2Unit:TextField=createLabel(x3,y,"MPa",textFormat);
      y+=p2Field.height+5;
      var t3Label:TextField=
      	createLabel(x,y,"Turbine Inlet Temp. T3:",textFormat);
      t3Field=createInput(x2,y,w,"350.0",textFormat);
      var t3Unit:TextField=createLabel(x3,y,"degC",textFormat);
      y+=t3Field.height+5;

      var drawButton:Button=new Button("draw",fgColor,bgColor,
      	      	      	      	       x+w,y,textFormat);

      drawButton.addEventListener(MouseEvent.CLICK,draw);

      sprite.addChild(drawButton);
      sprite.addChild(p1Label);
      sprite.addChild(p1Field);
      sprite.addChild(p1Unit);
      sprite.addChild(p2Label);
      sprite.addChild(p2Field);
      sprite.addChild(p2Unit);
      sprite.addChild(t3Label);
      sprite.addChild(t3Field);
      sprite.addChild(t3Unit);
    }

//--------------------------------------------------------------------//
// x쐬
    internal function createLabel(x:int,y:int,s:String,
      	      	      	      	  textFormat:TextFormat):TextField{
      var field:TextField=new TextField();
      field.defaultTextFormat=textFormat;
      field.selectable=false;
      field.background=true;
      field.text=s;
      field.x=x;
      field.y=y;
      field.width=field.textWidth+5;
      field.height=field.textHeight+5;
      return field;
    }

//--------------------------------------------------------------------//
// x쐬
    internal function createInput(x:int,y:int,w:int,s:String,
      	      	      	      	  textFormat:TextFormat):TextField{
      var field:TextField=new TextField();
      field.defaultTextFormat=textFormat;
      field.selectable=true;
      field.background=true;
      field.border=true;
      field.text=s;
      field.x=x;
      field.y=y;
      field.height=field.textHeight+5;
      field.width=w;
      field.type="input";
      return field;
    }

//--------------------------------------------------------------------//
// \}؂ւ
    internal function draw(event:Event):void{
      try{
      	view.cycle.setCondition(Number(p1Field.text),
      	      	      	      	Number(p2Field.text),
      	      	      	      	Number(t3Field.text));
      	view.cycle.createDiagram();
      	view.setDrawData();
      	view.setMessage("");
      }
      catch(e:Error){
      	view.setMessage("Error: "+e.message);
      }
      view.draw();
    }
  }
}
