package graph{
  import flash.display.Graphics;
  import flash.display.GraphicsPathCommand;

//--------------------------------------------------------------------//
// `NX
  public class DrawLines{

// `R}h
    internal var commands:Vector.<int>;

// `W
    internal var coords:Vector.<Number>;

//--------------------------------------------------------------------//
    public function DrawLines(count:int=0){
      if(count>0){
      	commands=new Vector.<int>(count,true);
      	coords=new Vector.<Number>(2*count,true);
      }
      else{
      	commands=new Vector.<int>();
      	coords=new Vector.<Number>();
      }
    }

//--------------------------------------------------------------------//
// ̕`ݒ肷
    public function setLine(i:int,x1:Number,y1:Number,
      	      	      	    x2:Number,y2:Number):void{
      commands[2*i]=GraphicsPathCommand.MOVE_TO;
      coords[4*i]=x1;
      coords[4*i+1]=y1;
      commands[2*i+1]=GraphicsPathCommand.LINE_TO;
      coords[4*i+2]=x2;
      coords[4*i+3]=y2;
    }

//--------------------------------------------------------------------//
// ̕`ݒ肷
    public function drawLine(x1:Number,y1:Number,
      	      	      	     x2:Number,y2:Number):void{
      if(coords.length>1){
      	var x0:Number=coords[coords.length-2];
      	var y0:Number=coords[coords.length-1];
      	if((x0==x1) && (y0==y1)){
      	  lineTo(x2,y2);
      	  return;
      	}
      }
      commands.push(GraphicsPathCommand.MOVE_TO);
      coords.push(x1);
      coords.push(y1);
      lineTo(x2,y2);
    }

//--------------------------------------------------------------------//
// ̕`ݒ肷
    internal function lineTo(x:Number,y:Number):void{
      commands.push(GraphicsPathCommand.LINE_TO);
      coords.push(x);
      coords.push(y);
    }

//--------------------------------------------------------------------//
// `悷
// graphics - `OtBbNX
    public function draw(graphics:Graphics):void{
      graphics.drawPath(commands,coords);
    }
  }
}
