package graph{
  import flash.display.Sprite;
  import flash.text.TextFormat;

//--------------------------------------------------------------------//
// ΐOt
  public class LogAxis extends GraphAxis{

//--------------------------------------------------------------------//
// sprite - eXvCg
// text - x
// textFormat - eLXg
    public function LogAxis(sprite:Sprite,text:String,
      	      	      	    textFormat:TextFormat){
      super(sprite,text,textFormat);
    }

//--------------------------------------------------------------------//
// Otڐݒ肷
// minValue - f[^ŏl
// maxValue - f[^ől
    public override function setScale(minValue:Number,maxValue:Number):void{
      if(scaleLabel!=null) clearLabel();
      if(minValue>=maxValue){
      	scaleMin=Math.floor(Math.log(maxValue)/Math.log(10.0));
      	scaleMax=scaleMin+1.0;
      	scale=1.0;
      }
      else{
      	scaleMin=Math.floor(Math.log(minValue)/Math.log(10.0));
      	scaleMax=Math.ceil(Math.log(maxValue)/Math.log(10.0));
      	scale=1.0;
      }
      setScaleLabel();
    }

//--------------------------------------------------------------------//
// Wݒ肷
// p0 ʒu
// range \͈
// direc @1F@-1F
    public override function setCoef(p0:int,range:int,direc:int):void{
      coef1=Number(direc*range)/((scaleMax-scaleMin)*Math.log(10.0));
      coef0=Number(p0)-coef1*scaleMin*Math.log(10.0);
    }

//--------------------------------------------------------------------//
// f[^`ʒuɕϊ
// x f[^
    public override function toView(x:Number):int{
      return int(coef1*Math.log(x)+coef0);
    }

//--------------------------------------------------------------------//
// `ʒuf[^ɕϊ
// x `ʒu
    public override function toData(x:Number):Number{
      return Math.exp((x-coef0)/coef1);
    }

//--------------------------------------------------------------------//
// ڐ̐l𕶎ɕϊ
    protected override function toLabel(s:Number):String{
      return "10^"+int(s);
    }

//--------------------------------------------------------------------//
// ڐ̐l`ʒuɕϊ
    protected override function fromScaleToView(s:Number):int{
      return toView(Math.pow(10.0,s));
    }
  }
}
