package steamtable{

//--------------------------------------------------------------------//
// ̓f[^
  public class PressureTable{

// xi[z
    public var t:Vector.<Number>;

// Cp[^i[z
    public var vv:Vector.<VaporVariable>;

//--------------------------------------------------------------------//
    public function PressureTable(){
      t=new Vector.<Number>();
      vv=new Vector.<VaporVariable>();
    }

//--------------------------------------------------------------------//
// f[^ݒ肷
    public function setCount(count:int):void{
      t=new Vector.<Number>(count,true);
      vv=new Vector.<VaporVariable>(count,true);
    }

//--------------------------------------------------------------------//
// f[^ݒ肷
// index - f[^̃CfbNX
// tt - x
// v - p[^
    public function setParameter(index:int,tt:Number,
      	      	      	      	 v:VaporVariable):void{
      t[index]=tt;
      vv[index]=v;
    }

//--------------------------------------------------------------------//
// xf[^͈͂𒴂Ă邩ǂԂ
// tt - x
    public function isOverT(tt:Number):Boolean{
      if(t[0]<t[t.length-1]){
      	return ((tt<t[0]) || (t[t.length-1]<tt));
      }
      else{
      	return ((tt>t[0]) || (t[t.length-1]>tt));
      }
    }

//--------------------------------------------------------------------//
// Ggs[f[^͈͂𒴂Ă邩ǂԂ
// ss - Ggs[
    public function isOverS(ss:Number):Boolean{
      if(vv[0].s<vv[vv.length-1].s){
      	return ((ss<vv[0].s) || (vv[vv.length-1].s<ss));
      }
      else{
      	return ((ss>vv[0].s) || (vv[vv.length-1].s>ss));
      }
    }

//--------------------------------------------------------------------//
// xɑΉf[^Ԃ
// pp 
// tt x
    public function getByT(pp:Number,tt:Number):StateVariable{
      if(t[0]<t[t.length-1]){
      	if(tt<=t[0]){
      	  return StateVariable.create(t[0],pp,vv[0]);
      	}
      	else if(tt>=t[t.length-1]){
      	  return StateVariable.create(t[t.length-1],pp,vv[t.length-1]);
      	}
      }
      else{
      	if(tt>=t[0]){
      	  return StateVariable.create(t[0],pp,vv[0]);
      	}
      	else if(tt<=t[t.length-1]){
      	  return StateVariable.create(t[t.length-1],pp,vv[t.length-1]);
      	}
      }
      var i:int=serachIndex(0,t.length-1,tt,t);
      var cc:Number=(tt-t[i])/(t[i+1]-t[i]);
      return new StateVariable(tt,pp,vv[i].v+cc*(vv[i+1].v-vv[i].v),
      	      	      	       vv[i].u+cc*(vv[i+1].u-vv[i].u),
      	      	      	       vv[i].h+cc*(vv[i+1].h-vv[i].h),
      	      	      	       vv[i].s+cc*(vv[i+1].s-vv[i].s));
  }

//--------------------------------------------------------------------//
/// Ggs[ɑΉf[^Ԃ
// pp 
// ss Ggs[
    public function getByS(pp:Number,ss:Number):StateVariable{
      if(vv[0].s<vv[t.length-1].s){
      	if(ss<=vv[0].s){
      	  return StateVariable.create(t[0],pp,vv[0]);
      	}
      	else if(ss>=vv[t.length-1].s){
      	  return StateVariable.create(t[t.length-1],pp,vv[t.length-1]);
      	}
      }
      else{
      	if(ss>=vv[0].s){
      	  return StateVariable.create(t[0],pp,vv[0]);
      	}
      	else if(ss<=vv[t.length-1].s){
      	  return StateVariable.create(t[t.length-1],pp,vv[t.length-1]);
      	}
      }
      var i:int=serachIndexS(0,t.length-1,ss,vv);
      var cc:Number=(ss-vv[i].s)/(vv[i+1].s-vv[i].s);
      return new StateVariable(t[i]+cc*(t[i+1]-t[i]),pp,
      	      	      	       vv[i].v+cc*(vv[i+1].v-vv[i].v),
      	      	      	       vv[i].u+cc*(vv[i+1].u-vv[i].u),
      	      	      	       vv[i].h+cc*(vv[i+1].h-vv[i].h),ss);
    }

//--------------------------------------------------------------------//
// f[^YCfbNX
// low - CfbNX̉
// high - CfbNX̏
// v - f[^̒l
// array - f[^z
    public static function serachIndex(low:int,high:int,v:Number,
      	      	      	      	       array:Vector.<Number>):int{
      if(array[low]<array[high]){
      	do{
      	  var mid:int=(low+high)/2;
      	  if(array[mid]<=v)     low=mid+1;
      	  else if(array[mid]>v) high=mid;
      	}while(low<high);
      }
      else{
      	do{
      	  mid=(low+high)/2;
      	  if(array[mid]>=v)     low=mid+1;
      	  else if(array[mid]<v) high=mid;
      	}while(low<high);
      }
      return (low+high)/2-1;
    }

//--------------------------------------------------------------------//
// f[^YCfbNX
// low - CfbNX̉
// high - CfbNX̏
// v - f[^̒l
// vv - f[^z
    public static function serachIndexS(low:int,high:int,v:Number,
      	      	      	      	      	vv:Vector.<VaporVariable>):int{
      if(vv[low].s<vv[high].s){
      	do{
      	  var mid:int=(low+high)/2;
      	  if(vv[mid].s<=v)     low=mid+1;
      	  else if(vv[mid].s>v) high=mid;
      	}while(low<high);
      }
      else{
      	do{
      	  mid=(low+high)/2;
      	  if(vv[mid].s>=v)     low=mid+1;
      	  else if(vv[mid].s<v) high=mid;
      	}while(low<high);
      }
      return (low+high)/2-1;
    }
  }
}
