package steamtable{
  import flash.events.Event;
  import flash.events.EventDispatcher;

//--------------------------------------------------------------------//
// C\ǂݍ݃NX
  public class SteamTableReader extends EventDispatcher{

//--------------------------------------------------------------------//
// f[^ǂݍ
    public function readData(fileName:String,table:SteamTable):void{
      var data:TableData=new TableData();
      data.readData(fileName);
      data.addEventListener(TableData.LOAD_COMPLETE,onTextLoaded);

      function onTextLoaded(event:Event):void{
      	var ii:int=0;
      	var count:int,i:int,j:int;
      	var sv:SaturatedVapor=table.saturatedVapor;
      	var hv:SteamTableData=table.heatedVapor;
      	var cw:SteamTableData=table.compressedWater;
      	while(ii<data.array.length){
      	  if(data.array[ii].length>=2){
      	    var keyWord:String=data.array[ii][0].toLowerCase();
      	    if(keyWord=="saturatedvapor"){
      	      count=int(data.array[ii][1]);
      	      sv.setCount(count);
      	      for(i=0;i<count;i++){
      	      	ii++;
      	      	sv.setParameter(i,Number(data.array[ii][0]),
      	      	      	      	Number(data.array[ii][1]),
      	      	      	      	getVariable(2,data.array[ii]),
      	      	      	      	getVariable(6,data.array[ii]));
      	      }
      	    }
      	    else if(keyWord=="superheatedvapor"){
      	      count=int(data.array[ii][1]);
      	      hv.setPressCount(count);
      	      for(i=0;i<count;i++){
      	      	ii++;
      	      	var m:int=int(data.array[ii][1]);
      	      	hv.setTempCount(i,m);
      	      	hv.setPressure(i,Number(data.array[ii][0]));
      	      	for(j=0;j<m;j++){
      	      	  ii++;
      	      	  hv.setParameter(i,j,Number(data.array[ii][0]),
      	      	      	      	  getVariable(1,data.array[ii]));
      	      	}
      	      }
      	    }
      	    else if(keyWord=="compressedwater"){
      	      count=int(data.array[ii][1]);
      	      cw.setPressCount(count);
      	      for(i=0;i<count;i++){
      	      	ii++;
      	      	m=int(data.array[ii][1]);
      	      	cw.setTempCount(i,m);
      	      	cw.setPressure(i,Number(data.array[ii][0]));
      	      	for(j=0;j<m;j++){
      	      	  ii++;
      	      	  cw.setParameter(i,j,Number(data.array[ii][0]),
      	      	      	      	  getVariable(1,data.array[ii]));
      	      	}
      	      }
      	    }
      	  }
      	  ii++;
      	}
      	dispatchEvent(new Event(TableData.LOAD_COMPLETE));
      }
    }

//--------------------------------------------------------------------//
// Cp[^ǂݍ
// i - JnCfbNX
// array - f[^z
    public function getVariable(i:int,array:Array):VaporVariable{
      return new VaporVariable(Number(array[i]),Number(array[i+1]),
      	      	      	       Number(array[i+2]),Number(array[i+3]));
    }
  }
}
