package steamtable{

//--------------------------------------------------------------------//
// ԗ
  public class SteamTableData{

// ͂i[z
    public var p:Vector.<Number>;

// p[^i[z
    public var data:Vector.<PressureTable>;

//--------------------------------------------------------------------//
// f[^ݒ肷
    public function setPressCount(count:int):void{
      p=new Vector.<Number>(count,true);
      data=new Vector.<PressureTable>(count,true);
      for(var i:int=0;i<count;i++){
      	data[i]=new PressureTable();
      }
    }

//--------------------------------------------------------------------//
// xf[^ݒ肷
// index - ̓f[^̃CfbNX
// count - xf[^
    public function setTempCount(index:int,count:int):void{
      data[index].setCount(count);
    }

//--------------------------------------------------------------------//
// ͂ݒ肷
// index - ͂̃CfbNX
// p - 
    public function setPressure(index:int,p:Number):void{
      this.p[index]=p;
    }

//--------------------------------------------------------------------//
// f[^ݒ肷
// index1 - ͂̃CfbNX
// index2 - xf[^̃CfbNX
// t - x
// vp - p[^
    public function setParameter(index1:int,index2:int,t:Number,
      	      	      	      	 vp:VaporVariable):void{
      data[index1].setParameter(index2,t,vp);
    }

//--------------------------------------------------------------------//
// ́ExɑΉf[^Ԃ
// pp - 
// tt - x
    public function getByPT(pp:Number,tt:Number):StateVariable{
      if(pp<=p[0]){
      	return data[0].getByT(pp,tt);
      }
      else if(pp>=p[p.length-1]){
      	return data[p.length-1].getByT(pp,tt);
      }
      else{
      	var i:int=PressureTable.serachIndex(0,p.length-1,pp,p);
      	var cc:Number=(pp-p[i])/(p[i+1]-p[i]);
      	var sv1:StateVariable=data[i].getByT(pp,tt);
      	var sv2:StateVariable=data[i+1].getByT(pp,tt);
      	if(data[i].isOverT(tt)){
      	  var sv3:StateVariable=
      	    data[i+1].getByT(pp,(tt+(cc-1.0)*sv1.t)/cc);
      	  return new StateVariable(tt,pp,sv1.v+cc*(sv3.v-sv1.v),
      	      	      	      	   sv1.u+cc*(sv3.u-sv1.u),
      	      	      	      	   sv1.h+cc*(sv3.h-sv1.h),
      	      	      	      	   sv1.s+cc*(sv3.s-sv1.s));
      	}
      	else if(data[i+1].isOverT(tt)){
      	  sv3=data[i].getByT(pp,(tt-cc*sv2.t)/(1.0-cc));
      	  return new StateVariable(tt,pp,sv3.v+cc*(sv2.v-sv3.v),
      	      	      	      	   sv3.u+cc*(sv2.u-sv3.u),
      	      	      	      	   sv3.h+cc*(sv2.h-sv3.h),
      	      	      	      	   sv3.s+cc*(sv2.s-sv3.s));
      	}
      	else{
      	  return new StateVariable(tt,pp,sv1.v+cc*(sv2.v-sv1.v),
      	      	      	      	   sv1.u+cc*(sv2.u-sv1.u),
      	      	      	      	   sv1.h+cc*(sv2.h-sv1.h),
      	      	      	      	   sv1.s+cc*(sv2.s-sv1.s));
      	}
      }
    }

//--------------------------------------------------------------------//
// ́EGgs[ɑΉf[^Ԃ
// pp - 
// ss - Ggs[
    public function getByPS(pp:Number,ss:Number):StateVariable{
      if(pp<=p[0]){
      	return data[0].getByS(pp,ss);
      }
      else if(pp>=p[p.length-1]){
      	return data[p.length-1].getByS(pp,ss);
      }
      else{
      	var i:int=PressureTable.serachIndex(0,p.length-1,pp,p);
      	var cc:Number=(pp-p[i])/(p[i+1]-p[i]);
      	var sv1:StateVariable=data[i].getByS(pp,ss);
      	var sv2:StateVariable=data[i+1].getByS(pp,ss);
      	if(data[i].isOverS(ss)){
      	  var sv3:StateVariable=
      	    data[i+1].getByS(pp,(ss+(cc-1.0)*sv1.s)/cc);
      	  return new StateVariable(sv1.t+cc*(sv3.t-sv1.t),pp,
      	      	      	      	   sv1.v+cc*(sv3.v-sv1.v),
      	      	      	      	   sv1.u+cc*(sv3.u-sv1.u),
      	      	      	      	   sv1.h+cc*(sv3.h-sv1.h),ss);
      	}
      	else if(data[i+1].isOverS(ss)){
      	  sv3=data[i].getByS(pp,(ss-cc*sv2.s)/(1.0-cc));
      	  return new StateVariable(sv3.t+cc*(sv2.t-sv3.t),pp,
      	      	      	      	   sv3.v+cc*(sv2.v-sv3.v),
      	      	      	      	   sv3.u+cc*(sv2.u-sv3.u),
      	      	      	      	   sv3.h+cc*(sv2.h-sv3.h),ss);
      	}
      	else{
      	  return new StateVariable(sv1.t+cc*(sv2.t-sv1.t),pp,
      	      	      	      	   sv1.v+cc*(sv2.v-sv1.v),
      	      	      	      	   sv1.u+cc*(sv2.u-sv1.u),
      	      	      	      	   sv1.h+cc*(sv2.h-sv1.h),ss);
      	}
      }
    }
  }
}
